#include <windows.h>
#include <stdio.h>
#include <initguid.h>
#include <ddraw.h>
#include <d3d.h>

#define RELEASE(x) if (x) { (x)->Release(); (x)=NULL; }
#pragma comment(lib, "ddraw")

HWND hwnd;
BOOL bQuit=FALSE;
char szClassName[ ] = "WindowsApp";

// DirectX
LPDIRECTDRAW lpDD;
DDSURFACEDESC ddsd;
D3DVIEWPORT d3dviewport;
static int s_nLine;
//LPDIRECTDRAW4 s_lpDD = NULL;
LPDIRECTDRAWSURFACE s_lpDDSPrimary = NULL;
LPDIRECTDRAWSURFACE backbuffer = NULL;
LPDIRECT3D2 s_lpD3D = NULL;
LPDIRECT3DDEVICE2 s_lpD3DDevice = NULL;
LPDIRECT3DVIEWPORT2 s_lpD3DViewport = NULL;
// texturing
D3DTEXTUREHANDLE htexture;
LPDIRECTDRAWSURFACE mptexture;
LPDIRECT3DTEXTURE2 texture;
HDC texturedc;
HBITMAP texbmp;

// 3d
float xx, xy, yx, yy, a, t;

void cleanup(void){
  if (s_lpD3DDevice && s_lpD3DViewport){
    s_lpD3DDevice->DeleteViewport(s_lpD3DViewport);
  }
  RELEASE(s_lpD3DViewport);
  RELEASE(s_lpD3DDevice);
  RELEASE(s_lpD3D);
  RELEASE(s_lpDDSPrimary);
  RELEASE(lpDD);
}

void dxerror(void){
  RELEASE(lpDD);
  cleanup();
//  DestroyWindow(swnd);
  DestroyWindow(hwnd);
  bQuit=TRUE;
  exit(0);
}

LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)                  /* handle the messages */
    {
           case WM_DESTROY:
           PostQuitMessage(0);        /* send a WM_QUIT to the message queue */
           break;
           default:                   /* for messages that we don't deal with */
           return DefWindowProc(hwnd, message, wParam, lParam);
    }
    return 0;
}

int WINAPI WinMain(HINSTANCE hThisInstance, HINSTANCE hPrevInstance, LPSTR lpszArgument, int nFunsterStil){
  MSG messages;            /* Here messages to the application are saved */
  WNDCLASS wincl; 
  wincl.hInstance = hThisInstance;
  wincl.lpszClassName = szClassName;
  wincl.lpfnWndProc = WindowProcedure;    
  wincl.style = CS_DBLCLKS;               
  wincl.hIcon = LoadIcon(NULL, IDI_APPLICATION);
  wincl.hCursor = LoadCursor(NULL, IDC_ARROW);
  wincl.lpszMenuName = NULL;
  wincl.cbClsExtra = 0;                   
  wincl.cbWndExtra = 0;                   
  wincl.hbrBackground = (HBRUSH) GetStockObject(LTGRAY_BRUSH);
  if(!RegisterClass(&wincl)) return 0;
  hwnd = CreateWindow(
           /*"STATIC"*/szClassName,
           "Triangle Dev",         /* Title Text */
           WS_OVERLAPPEDWINDOW,
           0,
           0,
           640,                 /* The programs width */
           480,                 /* and height in pixels */
           HWND_DESKTOP,        /* The window is a child-window to desktop */
           NULL,                /* No menu */
           hThisInstance,       /* Program Instance handler */
           NULL                 /* No Window Creation data */
           );
//  swnd = CreateWindow("STATIC","Triangle Dev Static",0,0,0,544,375,
//                      HWND_DESKTOP,NULL,hThisInstance,NULL);
  /* Make the window visible on the screen */
  ShowWindow(hwnd, SW_MAXIMIZE);
//  ShowWindow(swnd, SW_MAXIMIZE);
  // Init DirectX and Direct3D
  // cretae direct draw object on primary surface
  if (DirectDrawCreate(NULL, &lpDD, NULL )!=DD_OK) dxerror();
  // create a DX6 version of the interface
//  if (lpDD->QueryInterface(IID_IDirectDraw, (LPVOID*)&lpDD)!=DD_OK) dxerror();
  // we're done with the DD1 interface
  // set the cooperative level
  if (lpDD->SetCooperativeLevel(hwnd, DDSCL_FULLSCREEN  | DDSCL_EXCLUSIVE | DDSCL_ALLOWMODEX)!=DD_OK) dxerror();
  lpDD->SetDisplayMode(640,480,16);
  // create the primary surface
  ZeroMemory(&ddsd, sizeof(ddsd));
  ddsd.dwSize = sizeof(ddsd);
  ddsd.dwFlags = DDSD_CAPS;
  ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;
  if (lpDD->CreateSurface(&ddsd, &s_lpDDSPrimary, NULL )!=DD_OK) dxerror();
  // Create backbuffer
	ZeroMemory(&ddsd, sizeof(ddsd));
	ddsd.dwSize = sizeof(ddsd);
	ddsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT;
	ddsd.dwWidth = 640;
	ddsd.dwHeight = 480;
    ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | DDSCAPS_3DDEVICE | DDSCAPS_VIDEOMEMORY;
	if (lpDD->CreateSurface(&ddsd, &backbuffer, NULL) != DD_OK){
  	  ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | DDSCAPS_3DDEVICE | DDSCAPS_SYSTEMMEMORY;
  	  if (lpDD->CreateSurface(&ddsd, &backbuffer, NULL) != DD_OK) dxerror();
    }
	if (s_lpDDSPrimary->AddAttachedSurface(backbuffer) != DD_OK) dxerror();
  // get the direct3d object
  if (lpDD->QueryInterface(IID_IDirect3D2, (LPVOID*)&s_lpD3D)!=DD_OK) dxerror();
  // create the direct 3d device from the surface using the RGB rasterizer
  if (s_lpD3D->CreateDevice(IID_IDirect3DHALDevice,backbuffer, &s_lpD3DDevice)!=DD_OK){
    if (s_lpD3D->CreateDevice(IID_IDirect3DRGBDevice,backbuffer, &s_lpD3DDevice)!=DD_OK){
      dxerror();
    }  
  }  
  // get the surface description so we know the width & height
  if (s_lpDDSPrimary->GetSurfaceDesc(&ddsd)!=DD_OK) dxerror();
  // create the viewport
  if (s_lpD3D->CreateViewport(&s_lpD3DViewport, NULL)!=D3D_OK) dxerror();
  // set viewport data
  ZeroMemory(&d3dviewport, sizeof(d3dviewport));
  d3dviewport.dwSize = sizeof(d3dviewport);
  d3dviewport.dwX = 0;
  d3dviewport.dwY = 0;
  d3dviewport.dwWidth = ddsd.dwWidth;
  d3dviewport.dwHeight = ddsd.dwHeight;
  d3dviewport.dvScaleX = ddsd.dwWidth/2;
  d3dviewport.dvScaleY = ddsd.dwHeight/2;
/*  d3dviewport.dvClipX = -1.0f;
  d3dviewport.dvClipY = 1.0f;
  d3dviewport.dvClipWidth = 2.0f;
  d3dviewport.dvClipHeight = 2.0f;*/
  d3dviewport.dvMinZ = 0.0f;
  d3dviewport.dvMaxZ = 1.0f;
  d3dviewport.dvMaxX = 1.0f;
  d3dviewport.dvMaxY = 1.0f;
  if (s_lpD3DDevice->AddViewport(s_lpD3DViewport)!=DD_OK) dxerror();
  if (s_lpD3DViewport->SetViewport(&d3dviewport)!=DD_OK) dxerror();
  if (s_lpD3DDevice->SetCurrentViewport(s_lpD3DViewport)!=DD_OK) dxerror();
  // texturing
  ZeroMemory(&ddsd, sizeof(ddsd));
  ddsd.dwSize = sizeof(ddsd);
  ddsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT;
  ddsd.dwWidth = 64;
  ddsd.dwHeight = 64;
  ddsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE | DDSCAPS_VIDEOMEMORY;
  if(lpDD->CreateSurface(&ddsd, &mptexture, NULL)!=D3D_OK){
    ddsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE | DDSCAPS_SYSTEMMEMORY;
    lpDD->CreateSurface(&ddsd, &mptexture, NULL);  
  }
  mptexture->GetDC(&texturedc);
/*  texbmp=CreateCompatibleBitmap(texturedc,64, 64);
  HDC texdc=CreateCompatibleDC(texturedc);
  HBITMAP old=(HBITMAP)SelectObject(texdc, (void*)texbmp);*/
  for(int i=0;i<64;i++){
    for(int j=0;j<64;j++){
      SetPixel(texturedc, i, j, 255*(sin(((i-32)*(i-32)+(j-32)*(j-32))/200.0)+1.0)/2.0);
    }
  }    
/*  BitBlt(texturedc, 0, 0, 64, 64, texdc, 0, 0, SRCCOPY);
  DeleteObject(SelectObject(texdc, old));
  DeleteDC(texdc);
  DeleteObject(texbmp);*/
/*  DeleteObject(SelectObject(texturedc,(HBRUSH) GetStockObject(LTGRAY_BRUSH)));
  DeleteObject(SelectObject(texturedc,(HPEN) GetStockObject(BLACK_PEN)));
  Rectangle(texturedc, 0, 0, 63, 63);
  SetPixel(texturedc, 10, 10, 0x00000000);*/
  mptexture->ReleaseDC(texturedc);
  if(mptexture->QueryInterface(IID_IDirect3DTexture2, (LPVOID *)&texture) != S_OK) dxerror();
  texture->GetHandle(s_lpD3DDevice, (DWORD*)&htexture);
  texture->Release();
  // set up 3d
  a=0;
  t=0;
  xx=1;
  xy=0;
  yx=0;
  yy=1;
  // render
  while ( !bQuit ) {
    if ( PeekMessage( &messages, NULL, 0, 0, PM_REMOVE ) ) {
      if ( messages.message == WM_QUIT ) {
        bQuit=TRUE;
      } else {
        TranslateMessage( &messages );
        DispatchMessage( &messages );
      }
    } else {
      if (s_lpD3DDevice->BeginScene()!=D3D_OK) dxerror();
	  DDBLTFX bltfx;
  	  ZeroMemory(&bltfx, sizeof(bltfx));
  	  bltfx.dwSize = sizeof(bltfx);
      backbuffer->Blt(NULL,NULL,NULL,DDBLT_WAIT|DDBLT_COLORFILL,&bltfx);
      s_lpD3DDevice->SetRenderState(D3DRENDERSTATE_TEXTUREHANDLE, htexture);
      D3DTLVERTEX verts[] = {
      { 150.0f-100*xx+yx*200, 480.0f-200*yy+xy*100, 0.5f, 1.0f, RGBA_MAKE(255, 255, 255, 127),
      RGBA_MAKE(0,0,0,0), 0.0f, 0.0f },
      { 150.0f+yx*200, 480.0f-200*yy, 0.5f, 1.0f, RGBA_MAKE(255, 255, 255, 127),
      RGBA_MAKE(0,0,0,0), 1.0f, 0.0f },
      { 150.0f-100*xx, 480.0f+xy*100, 0.5f, 1.0f, RGBA_MAKE(255, 255, 255, 127),
      RGBA_MAKE(0,0,0,0), 0.0f, 1.0f }
      };
      if (s_lpD3DDevice->DrawPrimitive(D3DPT_TRIANGLELIST,
      D3DVT_TLVERTEX, (void*)&verts[ 0], 3, D3DDP_DONOTLIGHT | D3DDP_WAIT)!=D3D_OK) dxerror();
      D3DTLVERTEX verts2[] = {
      { 150.0f-100*xx, 480.0f+xy*100, 0.5f, 1.0f, RGBA_MAKE(255, 255, 255, 127),
      RGBA_MAKE(0,0,0,0), 0.0f, 1.0f },
      { 150.0f+yx*200, 480.0f-200*yy, 0.5f, 1.0f, RGBA_MAKE(255, 255, 255, 127),
      RGBA_MAKE(0,0,0,0), 1.0f, 0.0f },
      { 150.0f, 480.0f, 0.5f, 1.0f, RGBA_MAKE(255, 255, 255, 127),
      RGBA_MAKE(0,0,0,0), 1.0f, 1.0f }
      };
      if (s_lpD3DDevice->DrawPrimitive(D3DPT_TRIANGLELIST,
      D3DVT_TLVERTEX, (void*)&verts2[ 0], 3, D3DDP_DONOTLIGHT | D3DDP_WAIT)!=D3D_OK) dxerror();
      if (s_lpD3DDevice->EndScene()!=D3D_OK) dxerror();
  	  s_lpDDSPrimary->Flip(NULL,DDFLIP_WAIT);
      // 3d
      t+=0.005;
      if(t>1&&a>-3.141592654/2){
        a-=3.141592654/2/200;
        xx=cos(a);
        yy=cos(a);
        xy=sin(a);
        yx=-sin(a);
      }
    }
  }  
  cleanup();
//  DestroyWindow(swnd);
  DestroyWindow(hwnd);
  return 0;
}

